package provide TclGPH 1.0

proc RelWindow {wN rW rX1 rY1 rZ1 rX2 rY2 rZ2 sX1 sY1 sZ1 sX2 sY2 sZ2 {Pix N} } {
   global WinInfo GphInfo

   if { [info exists WinInfo($rW,Dimen)] == 0 } { return -1 }

   set GphInfo(curWin) $wN
   GPHinits WINDOW $wN

   set rV [GPHmapLims $sX1 $sY1 $sX2 $sY2]
   set sX1 [lindex $rV 0] ; set sY1 [lindex $rV 1]
   set sX2 [lindex $rV 2] ; set sY2 [lindex $rV 3]

   if { $sZ1 != $sZ2 } {
      set WinInfo($wN,Dimen) 2 
   } else { set WinInfo($wN,Dimen) 3 }

   if { $WinInfo($wN,corFmt) == 1 } {
      set xL $WinInfo($rW,pp0)
      set xU $WinInfo($rW,pp3)
      if { $WinInfo($rW,pa0) == 1 } {
         set Denom [expr log10( $xU / $xL) ]
         set rX1 [expr log10( $rX1 / $xL) / $Denom ]
         if { $WinInfo($wN,disFmt) == 1 } {
            set rX2 [expr log10($rX2) / $Denom ]
         } else { set rX2 [expr log10( $rX2 / $xL) / $Denom ] }
      } else {
         set Denom [expr $xU - $xL ]
         set rX1 [expr ($rX1 - $xL) / $Denom ]
         if { $WinInfo($wN,disFmt) == 1 } {
            set rX2 [expr $rX2 / $Denom ]
         } else { set rX2 [expr ( $rX2 - $xL) / $Denom ] }
      }

      set yL $WinInfo($rW,pp1)
      set yU $WinInfo($rW,pp4)
      if { $WinInfo($rW,pa1) == 1 } {
         set Denom [expr log10( $yU / $yL) ]
         set rY1 [expr log10( $rY1 / $yL) / $Denom ]
         if { $WinInfo($wN,disFmt) == 1 } {
            set rY2 [expr log10($rY2) / $Denom ]
         } else { set rY2 [expr log10( $rY2 / $yL) / $Denom ] }
      } else {
         set Denom [expr $yU - $yL ]
         set rY1 [expr ($rY1 - $yL) / $Denom ]
         if { $WinInfo($wN,disFmt) == 1 } {
            set rY2 [expr $rY2 / $Denom ]
         } else { set rY2 [expr ( $rY2 - $yL) / $Denom ] }
      }

#     if { $WinInfo($rW,Dimen) == 3 } {
#        set zL $WinInfo($rW,pp2)
#        set zU $WinInfo($rW,pp5)
#        if { $WinInfo($rW,pa2) == 1 } {
#           set Denom [expr log10( $zU / $zL) ]
#           set rZ1 [expr log10( $rZ1 / $zL) / $Denom ]
#           if { $WinInfo($wN,disFmt) == 1 } {
#              set rZ2 [expr log10($rZ2) / $Denom ]
#           } else { set rZ2 [expr log10( $rZ2 / $zL) / $Denom ] }
#        } else {
#           set Denom [expr $zU - $zL ]
#           set rZ1 [expr ($rZ1 - $zL) / $Denom ]
#           if { $WinInfo($wN,disFmt) == 1 } {
#              set rZ2 [expr $rZ2 / $Denom ]
#           } else { set rZ2 [expr ( $rZ2 - $zL) / $Denom ] }
#        }
#     }
   }

   set dX [expr $WinInfo($rW,r3) - $WinInfo($rW,r0) ]
   set dY [expr $WinInfo($rW,r4) - $WinInfo($rW,r1) ]
   set dZ [expr $WinInfo($rW,r5) - $WinInfo($rW,r2) ]
   set rX1 [expr $rX1 * $dX  + $WinInfo($rW,r0) ]
   set rY1 [expr $rY1 * $dY  + $WinInfo($rW,r1) ]
#  set rZ1 [expr $rZ1 * $dZ  + $WinInfo($rW,r2) ]
   if { $WinInfo($wN,disFmt) == 1 } {
      set rX2 [expr $rX2 * $dX ]
      set rY2 [expr $rY2 * $dY ]
#     set rZ2 [expr $rZ2 * $dZ ]
   } else {
      set rX2 [expr $rX2 * $dX  + $WinInfo($rW,r0) ]
      set rY2 [expr $rY2 * $dY  + $WinInfo($rW,r1) ]
#     set rZ2 [expr $rZ2 * $dZ  + $WinInfo($rW,r2) ]
   }

   if { $GphInfo(oStyle) == 0 } {
      GenWindow $wN $rX1 $rY1 $rZ1 $rX2 $rY2 $rZ2 $sX1 $sY1 $sZ1 $sX2 \
                $sY2 $sZ2 $Pix
   } else {
      GenWindow $wN [expr 1.0 - $rX1] $rY1 $rZ1 [expr 1.0 - $rX2] $rY2 $rZ2 \
                $sX1 $sY1 $sZ1 $sX2 $sY2 $sZ2 $Pix
   }

   if { ($WinInfo($rW,Type) == 2 ) || ($WinInfo($rW,Type) == 4 ) } { 
      set WinInfo($wN,type) 5
   } else { set WinInfo($wN,type) 3 }

   return 1
}
